<template>
  <div id='container'>
    <h1>Login</h1>
      <label>Email</label>
      <b-form-input type="text" v-model="email"/>
      <label>Mot de passe</label>
      <b-form-input type="password" v-model="password"/>
      <div v-if="errorText">
        {{ errorText }}
      </div>
      <button v-on:click="login" class='mt-5'>Envoyer</button>
  </div>
</template>

<script>
import Cookies from 'js-cookie'

export default {
  name: 'Login',

  data () {
    return {
      email: '',
      password: '',
      errorCode: '',
      errorText: '',
      user: '',
      token: ''
    }
  },
  methods: {
    login () {
      const requestOptions = {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify({ email: this.email, password: this.password, strategy: 'local' })
      }
      fetch('/authentication', requestOptions)
        .then(async response => {
          // On a une erreur de mot de passe ou de mail
          if (response.status !== 201) {
            this.errorText = await response.text()
          } else {
            const json = await response.json()
            this.user = json.user
            this.token = json.accessToken
            Cookies.set('user', this.user)
            Cookies.set('token', this.token)
            console.log(json)
            // Rediriger vers une page
            // window.location.href = '#/accueil'
          }
        })
    }
  }
}
</script>

<style scoped>
#container{
  width:30%;
  margin:0 auto;
  margin-top:5%;
}

h1{
  width: 60%;
  margin: 0 auto;
  padding-bottom: 100px;
  text-align: center;
  font-size: 5em;
}

form {
  /* Uniquement centrer le formulaire sur la page /
  margin: 0 auto;
  width: 100%;
  / Encadré pour voir les limites du formulaire /
  padding: 60px;
  border: 1px solid #53af57;
  background:#fff;
  border-radius: 1em;
}

label {
  / Pour être sûrs que toutes les étiquettes ont même taille et sont correctement alignées /
  font-size: 2.5em;
}

input {
  / Pour s'assurer que tous les champs texte ont la même police.
     Par défaut, les textarea ont une police monospace /
  font: 2em sans-serif;
  / Pour que tous les champs texte aient la même dimension */
  width: 100%;
  box-sizing: border-box;
  margin: 20px 0;
  padding: 20px 20px;
}

button {
  background-color: #53af57;
  color: white;
  padding: 25px 20px;
  width: 100%;
  font-size: 2.5em;
}

button:hover{
  background-color: white;
  color: #53af57;
  border: 1px solid #53af57
}
</style>
